<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
<xsl:import href="page_Components.xsl" />
<xsl:param name="targetpath" />
<xsl:param name="homepage" />
<xsl:output method="html" name="html"/>
<xsl:template match="/">
<xsl:value-of select="$targetpath" /> 
<!-- each Chapter -->
<xsl:for-each select="/Document/chapter">
<xsl:call-template name="framefileContent">
<xsl:with-param name="framefile" select="concat($targetpath,'/f_',fileName,'.htm')"/>
</xsl:call-template>
</xsl:for-each>
<!--homepage-->
<xsl:for-each select="/Document/chapter [@id='0']">
<xsl:call-template name="framefileContent">
<xsl:with-param name="framefile" select="$homepage"/>
</xsl:call-template>
</xsl:for-each>
</xsl:template>
<xsl:template name="framefileContent">
<xsl:param name="framefile" />
Generiere <xsl:value-of select="$framefile"/><xsl:text>
</xsl:text>
<!--output method mit NAME text ist wichtig, damit sich result-document darauf beziehen kann
<xsl:result-document href="{$tabfile}" format="text">-->
<xsl:result-document href="{$framefile}" format="html"
method="html">
<html>
<head><title><xsl:value-of select="name"/></title>
<META NAME = "author" content = "Daniel Quathamer"></META>
<META NAME = "copyright" content = "(c) 2010 Daniel Quathamer"></META>
<META NAME = "date" content ="10.08.2010 11:13:22"></META>
<LINK REL = "Start" href = "main.htm"></LINK>
<LINK REL = "Next" href = "DasBerichtssystemSup.htm "></LINK>
<LINK REL = "Prev" href = "DasBerichtssystemSup.htm "></LINK>
<LINK REL="stylesheet" type="text/css" href="superx.css"></LINK>
</head>
<frameset rows="30,*" framespacing="0" border="0">
<frame src="{concat('TOP0_',@id,'.htm')}" name = "{concat('TOP',@id)}" scrolling="no" frameborder="0" noresize="1">
<frameset cols = "250,*" > 
<frame src="{concat('TOC0_',@id,'.htm')}" name = "{concat('TOC',@id)}" />
<frame src="{concat(fileName,'.htm')}" name = "TOC1" />
</frameset>
</frame>
</frameset>
<noframes>Diese Seiten wurden fuer Frame-faehige Browser entwickelt; bitte klicken Sie folgende Datei an: <a href="{concat(fileName,'.htm')}"><xsl:value-of select="name" /></a>
</noframes>
</html>
</xsl:result-document>
</xsl:template>

</xsl:stylesheet>